//+------------------------------------------------------------------+
//|                                                   Stochastic RSI |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_color3  Aqua
#property indicator_color4  Magenta

//
//
//
//
//

extern string TimeFrame                    = "Current time frame";
extern int    RSI_Length                   = 14;
extern int    K_Stochastic_Length          = 7;
extern int    K_Slowing_Length             = 5;
extern int    KMaMode                      = MODE_SMA;
extern int    D_Slowing_Stochastic_Length  = 3;
extern int    DMaMode                      = MODE_SMA;
extern int    Price                        = 0;    
extern int    arrowSize                    = 1; 
extern bool   drawDivergences              = true;
extern bool   ShowClassicalDivergence      = true;
extern bool   ShowHiddenDivergence         = true;
extern bool   drawIndicatorTrendLines      = true;
extern bool   drawPriceTrendLines          = false;
extern string drawLinesIdentificator       = "stochrsidiverge1";
extern double divergearrowsDisplacement    = 0.001;
extern bool   divergenceAlert              = true;
extern bool   divergenceAlertsMessage      = true;
extern bool   divergenceAlertsSound        = true;
extern bool   divergenceAlertsEmail        = false;
extern bool   divergenceAlertsNotify       = false;
extern string divergenceAlertsSoundName    = "alert1.wav";
extern bool   Interpolate                  = true;

extern bool   DotsOnFirstBar               = true;
extern string note                         = "turn on Alert = true; turn off = false";
extern bool   alertsOn                     = true;
extern bool   alertsOnCurrent              = false;
extern bool   alertsMessage                = true;
extern bool   alertsSound                  = false;
extern bool   alertsEmail                  = false;
extern bool   alertsNotify                 = false;
extern string soundFile                    = "alert2.wav";

extern bool   arrowsVisible                = false;
extern string arrowsIdentifier             = "stochrsi Arrows1";
extern double arrowsDisplacement           = 1.0;
extern color  arrowsUpColor                = DeepSkyBlue;
extern color  arrowsDnColor                = PaleVioletRed;
extern int    arrowsUpCode                 = 241;
extern int    arrowsDownCode               = 242;
      

//
//
//
//
//

double stochRsi[];
double stochRsiSignal[];
double bullishDivergence[];
double bearishDivergence[];
double rsi[];
double stoch[];
double trend[];

//
//
//
//
//

string indicatorName;
string labelNames;

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,stochRsi);
   SetIndexBuffer(1,stochRsiSignal);    SetIndexStyle(1,DRAW_ARROW);             SetIndexArrow(1,108);
   SetIndexBuffer(2,bullishDivergence); SetIndexStyle(2,DRAW_ARROW,0,arrowSize); SetIndexArrow(2,233);
   SetIndexBuffer(3,bearishDivergence); SetIndexStyle(3,DRAW_ARROW,0,arrowSize); SetIndexArrow(3,234);  
   SetIndexBuffer(4,rsi);
   SetIndexBuffer(5,stoch);
   SetIndexBuffer(6,trend);

      //
      //
      //
      //
      //
      
      timeFrame     = stringToTimeFrame(TimeFrame);
      labelNames    = "StochasticRsi_DivergenceLine "+drawLinesIdentificator+":";
      indicatorName = timeFrameToString(timeFrame)+" StochasticRsi Divergence";
      IndicatorShortName(indicatorName);
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
   return(0);
}

int deinit()
{
   if (!calculateValue && arrowsVisible) deleteArrows();  
   int length=StringLen(labelNames);
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if(StringSubstr(name,0,length) == labelNames)  ObjectDelete(name);   
   }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { stochRsi[0] = limit+1; return(0); }   
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {      
      for (i=limit; i>=0; i--)
      {
          rsi[i]     = iRSI(NULL, 0, RSI_Length, Price,i);
          double min = rsi[ArrayMinimum(rsi,K_Stochastic_Length,i)];
          double max = rsi[ArrayMaximum(rsi,K_Stochastic_Length,i)];
          stoch[i]   = 0.5; if (min!=max) stoch[i] = 100.0*(rsi[i]-min)/(max-min); 
      }
      for (i=limit; i>=0; i--) stochRsi[i] = iMAOnArray(stoch,0,K_Slowing_Length,0,KMaMode,i);
      for (i=limit; i>=0; i--)
      { 
          stochRsiSignal[i] = iMAOnArray(stochRsi,0,D_Slowing_Stochastic_Length,0,DMaMode,i); 
             trend[i] = trend[i+1]; 
             if (stochRsi[i] > stochRsiSignal[i]) trend[i] =  1;
             if (stochRsi[i] < stochRsiSignal[i]) trend[i] = -1;
             manageArrow(i);
             if (drawDivergences)
             {
               CatchBullishDivergence(i);
               CatchBearishDivergence(i);
                 
             }
        }
        manageAlerts();
      return(0);
      }
      
      //
      //
      //
      //
      //
      
      int shift = -1; if (DotsOnFirstBar) shift=1;
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      for (i=limit;i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
         int x = iBarShift(NULL,timeFrame,Time[i+shift]);
            stochRsi[i]       = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Length,K_Stochastic_Length,K_Slowing_Length,KMaMode,D_Slowing_Stochastic_Length,DMaMode,Price,arrowSize,drawDivergences,ShowClassicalDivergence,ShowHiddenDivergence,drawIndicatorTrendLines,drawPriceTrendLines,drawLinesIdentificator,divergearrowsDisplacement,divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsEmail,divergenceAlertsNotify,divergenceAlertsSoundName,0,y);
            trend[i]          = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Length,K_Stochastic_Length,K_Slowing_Length,KMaMode,D_Slowing_Stochastic_Length,DMaMode,Price,arrowSize,drawDivergences,ShowClassicalDivergence,ShowHiddenDivergence,drawIndicatorTrendLines,drawPriceTrendLines,drawLinesIdentificator,divergearrowsDisplacement,divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsEmail,divergenceAlertsNotify,divergenceAlertsSoundName,6,y);
            bullishDivergence[i] = EMPTY_VALUE;
            bearishDivergence[i] = EMPTY_VALUE;
            manageArrow(i);
            if (x!=y)
            {
              stochRsiSignal[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Length,K_Stochastic_Length,K_Slowing_Length,KMaMode,D_Slowing_Stochastic_Length,DMaMode,Price,arrowSize,drawDivergences,ShowClassicalDivergence,ShowHiddenDivergence,drawIndicatorTrendLines,drawPriceTrendLines,drawLinesIdentificator,divergearrowsDisplacement,divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsEmail,divergenceAlertsNotify,divergenceAlertsSoundName,1,y);
            }
            manageArrow(i);
            int firstBar = iBarShift(NULL,0,iTime(NULL,timeFrame,y));
            if (i==firstBar)
            {
              bullishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Length,K_Stochastic_Length,K_Slowing_Length,KMaMode,D_Slowing_Stochastic_Length,DMaMode,Price,arrowSize,drawDivergences,ShowClassicalDivergence,ShowHiddenDivergence,drawIndicatorTrendLines,drawPriceTrendLines,drawLinesIdentificator,divergearrowsDisplacement,divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsEmail,divergenceAlertsNotify,divergenceAlertsSoundName,2,y);
              bearishDivergence[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RSI_Length,K_Stochastic_Length,K_Slowing_Length,KMaMode,D_Slowing_Stochastic_Length,DMaMode,Price,arrowSize,drawDivergences,ShowClassicalDivergence,ShowHiddenDivergence,drawIndicatorTrendLines,drawPriceTrendLines,drawLinesIdentificator,divergearrowsDisplacement,divergenceAlert,divergenceAlertsMessage,divergenceAlertsSound,divergenceAlertsEmail,divergenceAlertsNotify,divergenceAlertsSoundName,3,y); 
            }
            manageArrow(i);
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
               for(int k = 1; k < n; k++) stochRsi[i+k] = stochRsi[i] + (stochRsi[i+n] - stochRsi[i]) * k/n;
               manageArrow(i);
         }
   manageAlerts();
return(0);
}

//
//
//
//
//

void CatchBullishDivergence(int shift)
{
   shift++;
         bullishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"l"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"l"+"os" + DoubleToStr(Time[shift],0));            
   if(!IsIndicatorLow(shift)) return;  

   //
   //
   //
   //
   //
      
   int currentLow = shift;
   int lastLow    = GetIndicatorLastLow(shift+1);
   if (stochRsi[currentLow] > stochRsi[lastLow] && Low[currentLow] < Low[lastLow])
   {
     if (ShowClassicalDivergence)
     {
        bullishDivergence[currentLow] = stochRsi[currentLow] - divergearrowsDisplacement;
        if (drawPriceTrendLines)    DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],Aqua,STYLE_SOLID);
        if (drawIndicatorTrendLines)DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],stochRsi[currentLow],stochRsi[lastLow],Aqua,STYLE_SOLID);
        if (divergenceAlert)        DisplayAlert("Classical bullish divergence",currentLow);  
     }
                        
   }
     
   //
   //
   //
   //
   //
        
   if (stochRsi[currentLow] < stochRsi[lastLow] && Low[currentLow] > Low[lastLow])
   {
     if (ShowHiddenDivergence)
     {
        bullishDivergence[currentLow] = stochRsi[currentLow] - divergearrowsDisplacement;
        if (drawPriceTrendLines)     DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],Aqua,STYLE_DOT);
        if (drawIndicatorTrendLines) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],stochRsi[currentLow],stochRsi[lastLow],Aqua,STYLE_DOT);
        if (divergenceAlert)         DisplayAlert("Reverse bullish divergence",currentLow); 
     }
   }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CatchBearishDivergence(int shift)
{
   shift++; 
         bearishDivergence[shift] = EMPTY_VALUE;
            ObjectDelete(labelNames+"h"+DoubleToStr(Time[shift],0));
            ObjectDelete(labelNames+"h"+"os" + DoubleToStr(Time[shift],0));            
   if(IsIndicatorPeak(shift) == false) return;
   int currentPeak = shift;
   int lastPeak = GetIndicatorLastPeak(shift+1);

   //
   //
   //
   //
   //
      
   if (stochRsi[currentPeak] < stochRsi[lastPeak] && High[currentPeak]>High[lastPeak])
   {
     if (ShowClassicalDivergence)
     {
        bearishDivergence[currentPeak] = stochRsi[currentPeak] + divergearrowsDisplacement;
        if (drawPriceTrendLines)     DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],Red,STYLE_SOLID);
        if (drawIndicatorTrendLines) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],stochRsi[currentPeak],stochRsi[lastPeak],Red,STYLE_SOLID);
        if (divergenceAlert)         DisplayAlert("Classical bearish divergence",currentPeak);
     } 
                        
   }
   
   //
   //
   //
   //
   //

   if (stochRsi[currentPeak] > stochRsi[lastPeak] && High[currentPeak] < High[lastPeak])
   {
     if (ShowHiddenDivergence)
     {
        bearishDivergence[currentPeak] = stochRsi[currentPeak] + divergearrowsDisplacement;
        if (drawPriceTrendLines)     DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],Red,STYLE_DOT);
        if (drawIndicatorTrendLines) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],stochRsi[currentPeak],stochRsi[lastPeak],Red,STYLE_DOT);
        if (divergenceAlert)         DisplayAlert("Reverse bearish divergence",currentPeak);
     }
                         
   }   
}

//
//
//
//
//

bool IsIndicatorPeak(int shift)
{
   if(stochRsi[shift] >= stochRsi[shift+1] && stochRsi[shift] > stochRsi[shift+2] && stochRsi[shift] > stochRsi[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

bool IsIndicatorLow(int shift)
{
   if(stochRsi[shift] <= stochRsi[shift+1] && stochRsi[shift] < stochRsi[shift+2] && stochRsi[shift] < stochRsi[shift-1])
       return(true);
   else 
       return(false);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastPeak(int shift)
{
    for(int i = shift+5; i < Bars; i++)
    {
       if(stochRsi[i] >= stochRsi[i+1] && stochRsi[i] > stochRsi[i+2] && stochRsi[i] >= stochRsi[i-1] && stochRsi[i] > stochRsi[i-2])
         return(i);
    }
return(-1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int GetIndicatorLastLow(int shift)
{
    for (int i = shift+5; i < Bars; i++)
    {
       if (stochRsi[i] <= stochRsi[i+1] && stochRsi[i] < stochRsi[i+2] && stochRsi[i] <= stochRsi[i-1] && stochRsi[i] < stochRsi[i-2])
         return(i);
}
     
return(-1);
}

//
//
//
//
//

void DisplayAlert(string doWhat, int shift)
{
    string dmessage;
    static datetime lastAlertTime;
    if(shift <= 2 && Time[0] != lastAlertTime)
    {
      dmessage =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," StochasticRsi ",doWhat);
          if (divergenceAlertsMessage) Alert(dmessage);
          if (divergenceAlertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," StochasticRsi " +" "+dmessage));
          if (divergenceAlertsEmail)   SendMail(StringConcatenate(Symbol()," StochasticRsi "),dmessage);
          if (divergenceAlertsSound)   PlaySound(divergenceAlertsSoundName); 
          lastAlertTime = Time[0];
    }
}


//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    string label = labelNames+first+"os"+DoubleToStr(t1,0);
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//
//
//
//
//

void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
    int indicatorWindow = WindowFind(indicatorName);
    if (indicatorWindow < 0) return;
    
    //
    //
    //
    //
    //
    
    string label = labelNames+first+DoubleToStr(t1,0);
      ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, 0);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"Says BUY");
         if (trend[whichBar] ==-1) doAlert(whichBar,"Says SELL");
         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," StochasticRsi ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," StochasticRsi " +" "+message));
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," StochasticRsi "),message);
             if (alertsSound)   PlaySound(soundFile);
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1])
      {
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,arrowsUpCode  ,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,arrowsDownCode,true);
      }
   }
}               

//
//
//
//
//

//
//
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsDisplacement * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsDisplacement * gap);
}

//
//
//
//
//

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}






